EDIT - bug #8189

Allow configuration of 'user.home’ via the spring environment
03/21/2019 12:15 PM - Andreas Kohlbecker
Target version: Release 5.7

Severity: blocker Found in Version:

Description

By now it is only possible to configure the ${user.home} via the system properties. That means the only option to set the user.home
variable is via the jym command argument:

-Duser.home=/home/user/
The ${user.home} is crucial since it determines the location of the .cdmLibrary folder.

In end to end integration test (#8187) this is a big caveat since it requires the tests to be run with the correct -Duser.home argument
to. Which would be the source of a lot of errors an confusion.

Therefore | suggest to let CdmUltils use the spring environment to determine the ${user.home} variable, this would be fully compatible
with the current implementation but would also allow for more flexibility as it is needed in test contexts.

Related issues:

Related to EDIT - feature request #8187: Use Spring Environment instead of cu... New
Related to EDIT - task #8505: ConfigFileUtil: turn all spring bean methods in... Closed
Related to EDIT - task #2387: make name and location of ~/.cdmlibrary folder ... New
Related to EDIT - task #8513: CdmUltils: remove MUST_EXIST_FILE and getResourc... Closed

Associated revisions

Revision 9b55e525 - 03/21/2019 02:46 PM - Andreas Kohlbecker

ref #8189 CdmUltils uses the spring environment to find user.home

Revision 44b37b30 - 03/21/2019 02:46 PM - Andreas Kohlbecker
ref #8189 moving folder funstins from CdmUltils to ConfigFileUtil

Revision a23c2a31 - 03/21/2019 02:46 PM - Andreas Kohlbecker

ref #8189 moving ConfigFileUtil and AccountStore to cdmlib-persistence:eu.etaxonomy.cdm.config

Revision 110c97a6 - 03/21/2019 02:46 PM - Andreas Kohlbecker
ref #8189 moving method getFolderSeperator() back to CdmUtils

Revision 0df7271b - 03/21/2019 02:46 PM - Andreas Kohlbecker

ref #8189 ConfigFileUtil as spring bean in deafult context and tests implemented

Revision 17f913df - 03/21/2019 04:30 PM - Andreas Kohlbecker

ref #8189 removing unnecessary dependency from cdmlib-commons

Revision cf9ba327 - 03/21/2019 06:53 PM - Andreas Kohlbecker

ref #8189 cdmlib-remote.properties as not required property source fixes bug introduced in 9b55e525

Revision 55¢390a0 - 03/22/2019 11:26 AM - Andreas Kohlbecker
ref #8189 adapting taxeditor to changes in CdmUtils and ConfigFileUtil

Revision ab611430 - 03/22/2019 11:35 AM - Andreas Kohlbecker
ref #8189 organizing imports for ConfigFileUtil

Revision 460fe6fd - 03/22/2019 12:58 PM - Andreas Kohlbecker
ref #8189 DataSourceConfigurer using ConfigFileUtil correctly

Revision eacea571 - 03/22/2019 03:15 PM - Andreas Kohlbecker
ref #8189 DataSourceConfigurer @Autowiring ConfigFileUtil to init this bean before

Revision 6dd0caa2 - 03/25/2019 01:13 PM - Andreas Kohlbecker

ref #8189 better reporting of error conditions in AbstractWebApplicationConfigurer

Revision a4b97169 - 03/25/2019 01:15 PM - Andreas Kohlbecker

ref #8189 cdm-server stores parameters as initParameter instead as Attribute, this allows to access these via Spring Environment

Revision 9b7d57ff - 03/29/2019 03:23 PM - Andreas Kohlbecker

ref #8189 providing fallback method to retrieve the ~/.cdmLibrary folder without application context

Revision ¢1460d6c - 04/02/2019 11:32 AM - Andreas Kohlbecker

ref #8189 removing useless trailing slashes

Revision 4adf618f - 04/02/2019 01:24 PM - Andreas Kohlbecker
ref #8189 fixing invalid NULL check

Revision 945508b5 - 04/03/2019 10:15 AM - Andreas Kohlbecker
ref #8189 fallback method for getCdmHomeSubDir() and fixing bug in getCdmHomeDirFallback()

Revision bdc08221 - 04/03/2019 10:17 AM - Andreas Kohlbecker
ref #8189 using getCdmHomeDirFallback() when the appcontext is not yet available

Revision ee512dbf - 04/03/2019 10:32 AM - Andreas Kohlbecker
ref #8189 using getCdmHomeDirFallback() when the appcontext is not yet available - 2

Revision c2e4881e - 04/04/2019 09:13 AM - Katja Luther

changes in CdmServerinfo

Revision 508c257d - 04/15/2019 03:53 PM - Andreas Kohlbecker

ref #8189 CdmUltils uses the spring environment to find user.home

Revision 03d51e97 - 04/15/2019 03:53 PM - Andreas Kohlbecker
ref #8189 moving folder funstins from CdmUltils to ConfigFileUtil

Revision 98bb24f8 - 04/15/2019 03:53 PM - Andreas Kohlbecker

ref #8189 moving ConfigFileUtil and AccountStore to cdmlib-persistence:eu.etaxonomy.cdm.config

Revision 657ed46c¢ - 04/15/2019 03:53 PM - Andreas Kohlbecker
ref #8189 moving method getFolderSeperator() back to CdmUtils

Revision 69056744 - 04/15/2019 03:53 PM - Andreas Kohlbecker

ref #8189 ConfigFileUtil as spring bean in deafult context and tests implemented

Revision 6d27d83c - 04/15/2019 03:53 PM - Andreas Kohlbecker

ref #8189 removing unnecessary dependency from cdmlib-commons

Revision 78e019b6 - 04/15/2019 03:53 PM - Andreas Kohlbecker

ref #8189 cdmlib-remote.properties as not required property source fixes bug introduced in 9b55e525

Revision 9879222 - 04/15/2019 03:53 PM - Andreas Kohlbecker
ref #8189 DataSourceConfigurer using ConfigFileUtil correctly

Revision 94aa8075 - 04/15/2019 03:53 PM - Andreas Kohlbecker
ref #8189 DataSourceConfigurer @Autowiring ConfigFileUtil to init this bean before

Revision e25f9¢c08 - 04/15/2019 03:53 PM - Andreas Kohlbecker

ref #8189 better reporting of error conditions in AbstractWebApplicationConfigurer

Revision ebd1ecaf - 04/15/2019 03:53 PM - Andreas Kohlbecker

ref #8189 providing fallback method to retrieve the ~/.cdmLibrary folder without application context

Revision 06374015 - 04/15/2019 03:53 PM - Andreas Kohlbecker

ref #8189 removing useless trailing slashes

Revision 9d2efe36 - 04/15/2019 03:53 PM - Andreas Kohlbecker
ref #8189 fixing invalid NULL check

Revision c98bdf84 - 04/15/2019 03:53 PM - Andreas Kohlbecker
ref #8189 fallback method for getCdmHomeSubDir() and fixing bug in getCdmHomeDirFallback()

Revision 110bd37f - 05/17/2019 01:01 PM - Andreas Miiller

ref #8189 fix user.home in AccountStore

Revision ce87358e - 05/21/2019 10:09 PM - Andreas Miiller
ref #8189 adapt tests for ConfigFileUtilTest

Revision 7686835 - 09/03/2019 03:29 PM - Andreas Kohlbecker

ref #8505 renaming method to getResourceFolderSeperator() and adapting documentation

History

#1 - 03/21/2019 04:25 PM - Andreas Kohlbecker
- Status changed from New to Resolved

- % Done changed from 0 to 50

close issue if the changes are not causing any problems.

#2 - 03/21/2019 04:26 PM - Andreas Kohlbecker

- Related to feature request #8187: Use Spring Environment instead of custom code in AbstractWebApplicationConfigurer added

#3 - 04/11/2019 05:28 PM - Andreas Kohlbecker
- Status changed from Resolved to In Progress

- Target version changed from Release 5.6 to Release 5.7

now that the changes made for this ticket are no longer causing any problems | will do the next step: turning all sping bean methods into not statically
methods.

#4 - 05/13/2019 03:58 PM - Andreas Miiller
- Status changed from In Progress to Feedback
- Priority changed from New to Highest

- Severity changed from normal to blocker

The test ConfigFileUtilTest.testGetFolderSeperator does not work anymore on windows systems when running in maven (not tested other
environment)

#5 - 05/16/2019 11:35 AM - Andreas Kohlbecker

- Assignee changed from Andreas Kohlbecker to Andreas Mtiller
The test ConfigFileUtilTest.testGetFolderSeperator does not work anymore on windows systems when running in maven

Can you provide me the error message, stacktrace related to this failure?

The Method CdmUstils.getFolderSeperator() is completely redundant since File.separator is extected to provide the same Character. Why are we
having an own implementation for somting that java core does for us?

Assert.assertEquals (File.separator, CdmUtils.getFolderSeperator());

Therefore | suggest removing that method as well as the CdmUtils. MUST_EXIST_FILEand the according file in the resources folder.

#6 - 06/05/2019 12:14 PM - Andreas Miiller

Andreas Kohlbecker wrote:

The test ConfigFileUtilTest.testGetFolderSeperator does not work anymore on windows systems when running in maven

Can you provide me the error message, stacktrace related to this failure?

Here it is:

Tests run: 3, Failures: 1, Errors: 0, Skipped: 1, Time elapsed: 0.13 sec <<< FAILURE!
testGetFolderSeperator (eu.etaxonomy.cdm.config.ConfigFileUtilTest) Time elapsed: 0.06 sec <<< FAILURE!
org.junit.ComparisonFailure: expected:<[\]> but was:<[/]>

at org.junit.Assert.assertEquals (Assert.java:115)

at org.junit.Assert.assertEquals (Assert.java:144)

at eu.etaxonomy.cdm.config.ConfigFileUtilTest.testGetFolderSeperator (ConfigFileUtilTest. java:26)

at sun.reflect.NativeMethodAccessorImpl.invokeO (Native Method)

at sun.reflect.NativeMethodAccessorImpl.invoke (NativeMethodAccessorImpl. java:62)

at sun.reflect.DelegatingMethodAccessorImpl.invoke (DelegatingMethodAccessorImpl. java:43)

at java.lang.reflect.Method.invoke (Method. java:498)

at org.junit.runners.model.FrameworkMethod$l.runReflectiveCall (FrameworkMethod. java:50)

#7 - 06/05/2019 12:23 PM - Andreas Miuller
- Assignee changed from Andreas Miiller to Andreas Kohlbecker
Andreas Kohlbecker wrote:
The Method CdmUstils.getFolderSeperator() is completely redundant since File.separator is extected to provide the same Character. Why are we

having an own implementation for somting that java core does for us?

| can't see why it should be redundant. CdmUtils.getFolderSeperator differentiates if the code runs from a jar bundle or if it runs from commandline. In
the later case the first case you always need "/" as separator while in the later case it is OS dependendend and therefore the test fails.

Distinguishing this is e.g. important when term loading from csv files to distinguish the position of the csv files in the file system. If compiled to a jar
you need another folder separator then reading from the ordinary folder on Windows because on Windows File.separator <> "/".

But | agree that we should maybe rename CdmUstils.getFolderSeperator to make clear that it is only for this specific usecase and it is not a general
shortcut to replace File.separator

#8 - 06/05/2019 12:25 PM - Andreas Miiller

Therefore | do not agree to remove the method or to remove the MUST_EXIST_FILE (but we may remove if there is a better mechanism for this)

#9 - 06/05/2019 01:31 PM - Andreas Miiller
Andreas Kohlbecker wrote:
now that the changes made for this ticket are no longer causing any problems | will do the next step: turning all sping bean methods into not

statically methods.

Is this already done?

#10 - 06/05/2019 01:54 PM - Andreas Kohlbecker

Andreas Muller wrote:

Andreas Kohlbecker wrote:
now that the changes made for this ticket are no longer causing any problems | will do the next step: turning all sping bean methods into
not statically methods.

Is this already done?

Not yet!

#11 - 08/30/2019 04:46 PM - Andreas Kohlbecker
- Related to task #8505: ConfigFileUtil: turn all spring bean methods into not statical methods. added

#12 - 08/30/2019 04:50 PM - Andreas Kohlbecker
- Status changed from Feedback to Closed

- % Done changed from 50 to 100

all remaining tasks copied to #8505

and closing this ticket

#13 - 08/30/2019 06:04 PM - Andreas Kohlbecker

- Related to task #2387: make name and location of ~/.cdmlibrary folder configurable added

#14 - 08/30/2019 09:40 PM - Andreas Miiller
Andreas Muller wrote:
The test ConfigFileUtilTest.testGetFolderSeperator does not work anymore on windows systems when running in maven (not tested other

environment)

By the way, | set the test to ignore (or completely deleted it, don't remember) as it didn't make any sense to me

#15 - 09/03/2019 04:08 PM - Andreas Kohlbecker
- Related to task #8513: CdmUltils: remove MUST_EXIST_FILE and getResourceFolderSeperator() added

#16 - 09/03/2019 04:12 PM - Andreas Kohlbecker

Andreas Muller wrote:
Andreas Miiller wrote:
The test ConfigFileUtilTest.testGetFolderSeperator does not work anymore on windows systems when running in maven (not tested other
environment)

By the way, | set the test to ignore (or completely deleted it, don't remember) as it didn't make any sense to me

| removed this test as well as the getFolderSeperator() method and the MUST_EXIST_FILE, see #8513 for details.
